//
// Created by dawsh on 2/8/24.
//

namespace J3ML::Algorithm
{
    // Numerical model of a "Spring" object
    // Simulates any oscillating system i.e. a mass suspended from a spring.
    class Spring
    {
        float Dampening;
        float Stiffness;
        float Goal;
        float RestLength = 1.f;

        bool Overdamped() const;
        bool Undamped() const;
        bool Underdamped() const;
        bool CriticallyDamped() const;
    };
}