#include <J3ML/Geometry/Sphere.h>

namespace J3ML::Geometry
{

    bool Sphere::Contains(const LineSegment &lineseg) const {

    }

    void Sphere::ProjectToAxis(const Vector3 &direction, float &outMin, float &outMax) const
    {
        float d = Vector3::Dot(direction, Position);
        outMin = d - Radius;
        outMax = d + Radius;
    }

    Vector3 Sphere::ExtremePoint(const Vector3 &direction) const {
        float len = direction.Length();
        assert(len > 0.f);
        return Position + direction * (Radius / len);
    }

    Vector3 Sphere::ExtremePoint(const Vector3 &direction, float &projectionDistance) const {
        Vector3 extremePoint = ExtremePoint(direction);
        projectionDistance = extremePoint.Dot(direction);
        return extremePoint;
    }
}