#include <J3ML/J3ML.h>


namespace J3ML
{

    Math::Rotation Math::operator ""_degrees(long double rads) { return {Radians((float)rads)}; }

    Math::Rotation Math::operator ""_deg(long double rads) { return {Radians((float)rads)}; }

    Math::Rotation Math::operator ""_radians(long double rads) { return {(float)rads}; }

    Math::Rotation Math::operator ""_rad(long double rads) { return {(float)rads}; }

    float Math::FastRSqrt(float x) {
        return 1.f / FastSqrt(x);
    }

    float Math::RSqrt(float x) {
        return 1.f / Sqrt(x);
    }

    float Math::Radians(float degrees) { return degrees * (Pi/180.f); }

    float Math::Degrees(float radians) { return radians * (180.f/Pi); }

    bool Math::EqualAbs(float a, float b, float epsilon) {
        return std::abs(a - b) < epsilon;
    }

    float Math::RecipFast(float x) {
        // TODO: Implement SSE rcp instruction.
        return 1.f / x;
    }

    Math::Rotation::Rotation() : valueInRadians(0) {}

    Math::Rotation::Rotation(float value) : valueInRadians(value) {}

    Math::Rotation Math::Rotation::operator+(const Math::Rotation &rhs) {
        valueInRadians += rhs.valueInRadians;
    }

    float Math::Interp::SmoothStart(float t) {
        assert(t >= 0.f && t <= 1.f);
        return t*t;
    }

    int Math::BitTwiddling::CountBitsSet(u32 value) {

    }
}